/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2007-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_timer.h 722 2010-10-14 04:43:29Z ertl-honda $
 */

/*
 *  ޥɥ饤СAT91SKYEYEѡ
 */

#ifndef TOPPERS_TARGET_TIMER_H
#define TOPPERS_TARGET_TIMER_H

#include <sil.h>
#include "at91skyeye.h"

/*
 *  ޳ߥϥɥϿΤ
 */
/*
 *  륿Ѥ
 */
#define INHNO_TIMER_PRC1     (0x10000|IRQ_TC1)  /* ߥϥɥֹ */
#define INTNO_TIMER_PRC1     (0x10000|IRQ_TC1)  /* ֹ */
#define INTPRI_TIMER_PRC1    -6                 /* ͥ */
#define INTATR_TIMER_PRC1    0U                 /* ° */

#define INHNO_TIMER_PRC2     (0x20000|IRQ_TC1)  /* ߥϥɥֹ */
#define INTNO_TIMER_PRC2     (0x20000|IRQ_TC1)  /* ֹ */
#define INTPRI_TIMER_PRC2    -6                 /* ͥ */
#define INTATR_TIMER_PRC2    0U                 /* ° */

#define INHNO_TIMER_PRC3     (0x30000|IRQ_TC1)  /* ߥϥɥֹ */
#define INTNO_TIMER_PRC3     (0x30000|IRQ_TC1)  /* ֹ */
#define INTPRI_TIMER_PRC3    -6                 /* ͥ */
#define INTATR_TIMER_PRC3    0U                 /* ° */

#define INHNO_TIMER_PRC4     (0x40000|IRQ_TC1)  /* ߥϥɥֹ */
#define INTNO_TIMER_PRC4     (0x40000|IRQ_TC1)  /* ֹ */
#define INTPRI_TIMER_PRC4    -6                 /* ͥ */
#define INTATR_TIMER_PRC4    0U                 /* ° */

/*
 *  Х륿Ѥ
 */
#if TOPPERS_SYSTIM_PRCID == 1
#define INHNO_TIMER_SYSTIM    (0x10000|IRQ_TC1)  /* ߥϥɥֹ */
#define INTNO_TIMER_SYSTIM    (0x10000|IRQ_TC1)  /* ֹ */
#elif TOPPERS_SYSTIM_PRCID == 2
#define INHNO_TIMER_SYSTIM    (0x20000|IRQ_TC1)  /* ߥϥɥֹ */
#define INTNO_TIMER_SYSTIM    (0x20000|IRQ_TC1)  /* ֹ */
#elif TOPPERS_SYSTIM_PRCID == 3
#define INHNO_TIMER_SYSTIM    (0x30000|IRQ_TC1)  /* ߥϥɥֹ */
#define INTNO_TIMER_SYSTIM    (0x30000|IRQ_TC1)  /* ֹ */
#elif TOPPERS_SYSTIM_PRCID == 4
#define INHNO_TIMER_SYSTIM    (0x40000|IRQ_TC1)  /* ߥϥɥֹ */
#define INTNO_TIMER_SYSTIM    (0x40000|IRQ_TC1)  /* ֹ */
#endif /* TOPPERS_SYSTIM_PRCID == 1 */

#define INTPRI_TIMER_SYSTIM   -6    /* ͥ */
#define INTATR_TIMER_SYSTIM    0U   /* ° */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ͤɽη
 */
typedef uint32_t    CLOCK;

/*
 *  ͤɽȥߥáñ̤ȤѴ
 */
#define TIMER_CLOCK          2048U
#define TO_CLOCK(nume, deno) (TIMER_CLOCK * (nume) / (deno))
#define TO_USEC(clock)       (((SYSUTM) clock) * 1000U / TIMER_CLOCK)

/*
 *  ǤΥ޼ñ̤ɽ
 */
#define MAX_CLOCK        ((CLOCK) 0xffffffU)

/*
 *  ޤθͤȯͤȤߤʤȽ
 */
#define GET_TOLERANCE    100U    /* ٤θѤ͡ñ̤ɽ*/
#define BEFORE_IREQ(clock) \
            ((clock) >= TO_CLOCK(TIC_NUME, TIC_DENO) - GET_TOLERANCE)

/*
 *  ޤεư
 *
 *  ޤŪʥ޳׵ȯ롥
 */
extern void    target_timer_initialize(intptr_t exinf);

/*
 *  ޤ߽
 *
 *  ޤưߤ롥
 */
extern void    target_timer_terminate(intptr_t exinf);

/*
 *  ޤθͤɽФ
 */
Inline CLOCK
target_timer_get_current(void)
{
	return(TO_CLOCK(TIC_NUME, TIC_DENO) - sil_rew_mem((void *)TIMER_1_RC));
}

/*
 *  ޳׵Υå
 */
Inline bool_t
target_timer_probe_int(void)
{
	return(x_probe_int(IRQ_TC1));
}

/*
 *  ޳ߥϥɥ
 */
extern void    target_timer_handler(void);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_TARGET_TIMER_H */
